/* $Header: /cvsroot/sid/sid/user/c_tsw.c,v 1.25 2004/07/31 07:46:19 deppeler Exp $ */

#include "c_tsw.h"
#include "sha1_kernel.h"

int debug = 0;

int main(int argc, char **argv)
{
	struct cmd_line_t *cmd_line_opts;

	config = (struct config *)ecalloc(1, sizeof(struct config));

	setprogname("tsw");

	/* get args */
	cmd_line_opts = cmd_parse(argc, argv);
	if (cmdargs_check(cmd_line_opts) > 0) {
		usage();
		exit(-1);
	}
	debug = cmd_line_opts->debug;

	/* generate a hash only? */
	if (cmd_line_opts->s == 1) {
		if (gen_pass() != 0)
			eprintf
			    ("error generating hash: contact the author to fix the source. Exiting\n");
		exit(0);
	}

	/* parse configuration file */
	if (config_parse(cmd_line_opts->file) < 0) {
		eprintf
		    ("error: check configuration file syntax. Exiting ...\n");
	}

	/* fixup configuration data structure for runtime use, read in interactive 
	 * passwords (if necessary) */
	if (preprocess_config(config) > 0) {
		eprintf
		    ("error: configuration data preprocessing failed. Exiting ...\n");
	}

	/* fork to background */
	if (become_daemon(cmd_line_opts) < 0) {
		eprintf("error: forking to background failed");
	}

	if (tail_on_file(config) < 0) {
		perror("Exiting\n");
		exit(2);
	}

	free_all(config);
	return 0;
}

/* indent -kr -i8 -ts8 -sob -l80 -ss -ncs */
